
package de.ivu.elect.presentation.entschaedigung.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.datei.boundary.DateiExportExtendedDAO;
import de.ivu.elect.business.datei.entity.DateiExport;
import de.ivu.elect.business.entschaedigung.entity.Auszahlung;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.entschaedigung.exchange.AuszahlungExportDescription;
import de.ivu.elect.presentation.exchange.ExportDescriptionSelect;
import de.ivu.elect.presentation.exchange.action.DateiExportDownloadAction;

@Named(AuszahlungDownloadAction.COMPONENT_NAME)
public class AuszahlungDownloadAction extends AbstractAuszahlungAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "auszahlungDownloadAction";

  @Inject
  private transient DateiExportExtendedDAO dateiExportDao;

  @Inject
  private transient DateiExportDownloadAction dateiExportDownloadAction;

  @Inject
  private transient ExportDescriptionSelect exportDescriptionSelect;

  @Inject
  private transient AuszahlungExportDescription auszahlungExportDescription;

  public AuszahlungDownloadAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return auszahlungExportDescription.getUseCasePermission();
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Auszahlung auszahlung) {
    return super.isDisabledInternal(auszahlung) || !auszahlung.hasDateiExport() || !getDateiExportDownloadAction().isActionPossible(extractDateiExport(auszahlung));
  }

  @Override
  protected String doIt(Auszahlung auszahlung) {
    getDateiExportDownloadAction().doIt(extractDateiExport(auszahlung));

    return null;
  }

  @Override
  protected boolean isAsyncSupported() {
    return getDateiExportDownloadAction().isAsyncSupported();
  }

  @Override
  public String getLabelKey() {
    return getDateiExportDownloadAction().getLabelKey();
  }

  @Override
  public String getIcon() {
    return getDateiExportDownloadAction().getIcon();
  }

  private DateiExport extractDateiExport(Auszahlung auszahlung) {
    return dateiExportDao.attach(auszahlung.getDateiExport());
  }

  private DateiExportDownloadAction getDateiExportDownloadAction() {
    exportDescriptionSelect.setExportDescription(auszahlungExportDescription);

    return dateiExportDownloadAction;
  }
}
